#!/usr/bin/env python
# coding: utf-8

# In[32]:


from tkinter import *
import pandas as pd
import openpyxl


nombre = ''
nombreArchivo = ()

def datos():
    
    global nombre
    global documento
    
    
    root = Tk()
    
    root.geometry("600x300")
    root.resizable(False, False)
    root.config(bg = "lightblue")
    
    miframe = Frame(root, width="500", height="200")
    miframe.grid(row="0", column="0")
    
    root.title("Inventario de Depresión de Beck")
    T = Label(miframe, text="Antes de realizar el cuestionario, complete los siguientes datos:",
              anchor = "n", justify = "left", font=("Tahoma", 14), bg = "lightblue", padx = 20, pady = 20)
    T.grid(row="0", column="0")
    
    nombre = Entry(root)
    nombre.config(justify="center", width="40")
    nombre.grid(row="1",column="0", pady="10")
    
    cuadroNombre = Label(root, text="Nombre completo:")
    cuadroNombre.config(font=("Tahoma", 13), bg = "lightblue")
    cuadroNombre.grid(row="1",column="0", sticky="w", padx ="60", pady="20")
    
    documento = Entry(root)
    documento.config(justify="center", width="40")
    documento.grid(row="2",column="0", pady="10")
    
    cuadroDocumento = Label(root, text="Documento:")
    cuadroDocumento.config(font=("Tahoma", 13), bg = "lightblue")
    cuadroDocumento.grid(row="2",column="0", sticky="w", padx ="60", pady="20")
    
    
    def cerrarventana():
        root.destroy()
    
    def guardar_datos():
        
        global nombreArchivo
        global documento
                
        df = pd.DataFrame()
        nombreArchivo = str(nombre.get()) + '.xlsx'
        df.to_excel(nombreArchivo)

    b1 = Button(root, text = "Continuar", command = lambda:[guardar_datos(), cerrarventana()])
    b1.grid(row=3)

   
root = Tk()
root.geometry("800x450")
root.resizable(False, False)
root.config(bg = "lightblue")

miframe = Frame(root, width="500", height="200")
miframe.pack()

root.title("Inventario de Depresión de Beck")

T = Label(miframe, text="Inventario de Depresión de Beck \n\nInstrucciones: \n\nEste cuestionario consta de 21 grupos de afirmaciones. Por favor, lea con \natención cada uno de ellos cuidadosamente. Luego elija uno de cada grupo, \nel que mejor describa el modo como se ha sentido las últimas dos semanas,  \nincluyendo el día de hoy. \nMarque con un círculo el número correspondiente al enunciado elegido. \nSi varios enunciados de un mismo grupo le parecen igualmente apropiados, \nmarque el número más alto. \n\nSi está seguro de haber entendido las instrucciones, presione continuar""", 
    anchor = "n", justify = "left", font=("Tahoma", 14), bg="lightblue", padx = 20, pady = 20)
T.pack()

def cerrarventana():

	root.destroy()


b1 = Button(root, text = "Continuar", command = lambda: [datos(), cerrarventana()])
b1.config(bg="lightgrey")
b1.pack(pady="20")


root.mainloop()




PREGUNTAS = [

    {
        "item": "Tristeza",
        "opciones": {
            0: "No me siento triste.",
            1: "Me siento triste gran parte del tiempo.",
            2: "Me siento triste todo el tiempo.",
            3: "Me siento tan triste o soy tan infeliz que no puedo soportarlo."
        }
    },
    {
        "item": "Pesimismo",
        "opciones": {
            0: "No estoy desalentado respecto de mi futuro.",
            1: "Me siento mas desalentado respecto de mi futuro que  lo que solia estarlo.",
            2: "No espero que las cosas funcionen para mi.",
            3: "Siento que no hay esperanza para mi futuro y que sólo puede empeorar."
        }
    
    },
    {
        "item": "Fracaso",
        "opciones": {
            0: "No me siento como un fracasado.",
            1: "He fracasado más de lo que hubiera debido.",
            2: "Cuando miro hacia atrás, veo muchos fracasos.",
            3: "Siento que como persona soy un fracaso total."
        }
    },
    {
        "item": "Pérdida de Placer",
        "opciones": {
            0: "Obtengo tanto placer como siempre por las cosas de las que disfruto.",
            1: "No disfruto tanto de las cosas como solía hacerlo.",
            2: "Obtengo muy poco placer de las cosas que solía disfrutar.",
            3: "No puedo obtener ningún placer de las cosas de las que solía disfrutar."
        }
    },
    
    {
        "item": "Sentimientos de Culpa",
        "opciones": {
            0: "No me siento particularmente culpable.",
            1: "Me siento culpable respecto de varias cosas que he hecho o que debería haber hecho.",
            2: "Me siento bastante culpable la mayor parte del tiempo.",
            3: "Me siento culpable todo el tiempo."
        }
    },
    {
        "item": "Sentimientos de Castigo",
        "opciones": {
            0: "No siento que este siendo castigado",
            1: "Siento que tal vez pueda ser castigado.",
            2: "Espero ser castigado.",
            3: "Siento que estoy siendo castigado."
        }
    },
    {
        "item": "Disconformidad con uno mismo",
        "opciones": {
            0: "Siento acerca de mi lo mismo que siempre.",
            1: "He perdido la confianza en mí mismo.",
            2: "Estoy decepcionado conmigo mismo.",
            3: "No me gusto a mí mismo."
        }
    },
    {
        "item": "Autocrítica",
        "opciones": {
            0: "No me critico ni me culpo más de lo habitual.",
            1: "Estoy más crítico conmigo mismo de lo que solía estarlo.",
            2: "Me critico a mí mismo por todos mis errores.",
            3: "Me culpo a mí mismo por todo lo malo que sucede."
        }
    },
    {
        "item": "Pensamientos o Deseos Suicidas",
        "opciones": {
            0: "No tengo ningún pensamiento de matarme.",
            1: "He tenido pensamientos de matarme, pero no lo haría.",
            2: "Querría matarme.",
            3: "Me mataría si tuviera la oportunidad de hacerlo."
        }
    },
    {
        "item": "Llanto",
        "opciones": {
            0: "No lloro más de lo que solía hacerlo.",
            1: "Lloro más de lo que solía hacerlo.",
            2: "Lloro por cualquier pequeñez.",
            3: "Siento ganas de llorar pero no puedo."
        }
    },
    {
        "item": "Agitación",
        "opciones": {
            0: "No estoy más inquieto o tenso que lo habitual.",
            1: "Me siento más inquieto o tenso que lo habitual.",
            2: "Estoy tan inquieto o agitado que me es difícil quedarme quieto.",
            3: "Estoy tan inquieto o agitado que tengo que estar siempre en movimiento o haciendo algo."
        }
    },
    {
        "item": "Pérdida de Interés",
        "opciones": {
            0: "No he perdido el interés en otras actividades o personas.",
            1: "Estoy menos interesado que antes en otras personas o cosas.",
            2: "He perdido casi todo el interés en otras personas o cosas.",
            3: "Me es difícil interesarme por algo."
        }
    },
    {
        "item": "Indecisión",
        "opciones": {
            0: "Tomo mis propias decisiones tan bien como siempre.",
            1: "Me resulta más difícil que de costumbre tomar decisiones.",
            2: "Encuentro mucha más dificultad que antes para tomar decisiones.",
            3: "Tengo problemas para tomar cualquier decisión."
        }
    },
    {
        "item": "Desvalorización",
        "opciones": {
            0: "No siento que yo no sea valioso.",
            1: "No me considero a mi mismo tan valioso y útil como solía considerarme.",
            2: "Me siento menos valioso cuando me comparo con otros.",
            3: "Siento que no valgo nada."
        }
    },
    {
        "item": "Pérdida de Energía",
        "opciones": {
            0: "Tengo tanta energía como siempre.",
            1: "Tengo menos energía que la que solía tener.",
            2: "No tengo suficiente energía para hacer demasiado.",
            3: "No tengo energía suficiente para hacer nada."
        }
    },
    {
        "item": "Cambios en los Hábitos de Sueño",
        "opciones": {
            0: "No he experimentado ningún cambio en mis hábitos de sueño.",
            1: "Duermo un poco más o duermo un poco menos que lo habitual.",
            2: "Duermo mucho más o duermo mucho menos que lo habitual.",
            3: "Duermo la mayor parte del día o me despierto más temprano y no puedo volver a dormirme."
        }
    },
    {
        "item": "Irritabilidad",
        "opciones": {
            0: "No estoy tan irritable que lo habitual.",
            1: "Mi apetito es un poco menor o un poco mayor que lo habitual.",
            2: "Mi apetito es mucho menor o mucho mayor que antes.",
            3: "No tengo apetito en absoluto o quiero comer todo el día."
        }
    },
    {
        "item": "Cambios en el Apetito",
        "opciones": {
            0: "No he experimentado ningún cambio en mi apetito.",
            1: "Mi apetito es un poco menor que lo habitual.",
            2: "He perdido casi todo el interés en otras personas o cosas.",
            3: "Me es difícil interesarme por algo."
        }
    },
    {
        "item": "Dificultad de Concentración",
        "opciones": {
            0: "Puedo concentrarme tan bien como siempre.",
            1: "No puedo concentrarme tan bien como habitualmente.",
            2: "Me es difícil mantener la mente en algo por mucho tiempo.",
            3: "Encuentro que no puedo concentrarme en nada."
        }
    },
    {
        "item": "Cansancio o Fatiga",
        "opciones": {
            0: "No estoy más cansado o fatigado que lo habitual.",
            1: "Me fatigo o me canso más fácilmente que lo habitual.",
            2: "Estoy demasiado fatigado o cansado para hacer muchas de las cosas que solía hacer.",
            3: "Estoy demasiado fatigado o cansado para hacer la mayoría de las cosas que solía hacer."
        }
    },
    {
        "item": "Pérdida de Interés en el Sexo",
        "opciones": {
            0: "No he notado ningún cambio reciente en mi interés por el sexo.",
            1: "Estoy menos interesado en el sexo de lo que solía estarlo.",
            2: "Estoy mucho menos interesado en el sexo.",
            3: "He perdido completamente el interés en el sexo."
        }
    }
]

item_critico=[]
RESPUESTAS = []

def ventana_pregunta(dict_opciones, index):

    global RESPUESTAS
    global item_critico

    root = Tk()
    root.geometry("860x350")
    root.resizable(False, False)
    root.config(bg = "lightblue")
    root.title("Inventario de Depresión de Beck")

        
    item = Label(root, text=dict_opciones['item'], 
        anchor = "n", justify = "left", font=("Tahoma", 14), bg = "lightblue", 
        padx = 20, pady = 20).pack()

    sentimiento = IntVar()
    

    def valor2():

        global RESPUESTAS
        global item_critico

        RESPUESTAS += [{
            "item": dict_opciones['item'],
            "valor_respuesta": sentimiento.get()
        }]

        if sentimiento.get()== 3:
            item_critico += [ dict_opciones['item']]

    
    rbtns = []

    for valor, opcion in dict_opciones['opciones'].items():

        rbtns += [Radiobutton(
            root, 
            text=opcion,
            command=valor2,
            variable = sentimiento, 
            value=valor, font=("Tahoma", 14), 
            padx="40", 
            bg = "lightblue").pack(anchor = W)]


    b1 = Button(root, text = "Siguiente ventana",
    	command=lambda: siguiente_ventana(root, index + 1), 
    	font=("Tahoma", 12))
    b1.pack(pady = '10')

    root.mainloop()



def siguiente_ventana(root, index):

    root.destroy()
    ventana_pregunta(PREGUNTAS[index], index)
    
    if index ==20:
    	finalizar()

ventana_pregunta(PREGUNTAS[0], 0)
print('------------------------------------------------------------')
print()
print(RESPUESTAS)
print(item_critico)

SUMA = 0
for i in RESPUESTAS:
    SUMA += i['valor_respuesta']

print("la suma de las repsuestas es ", SUMA)

print("____________________________")



def nivel_depresion():
    
    global nivel
    
    if 10 < SUMA < 17:
        
        nivel = "Presenta leve perturbación del estado de ánimo."
    
    elif 16 < SUMA < 21:
        
        nivel = "Estados de depresión intermitentes. Puede requerir ayuda profesional."
            
    elif 20 < SUMA < 31:
        
            nivel = "Presenta depresión moderada."

    elif 30 < SUMA < 41:
            nivel = "Presenta depresión severa."

    elif SUMA >= 41:
            nivel = "Presenta depresión extrema."

    else:
        nivel = "No se presenta depresión."


    print(nivel)

    print("______________________")

nivel_depresion()


def finalizar():

    root = Tk()
    root.geometry("250x120")
    root.resizable(False, False)
    root.config(bg = "lightblue")

    miframe = Frame(root, width="200", height="100")
    miframe.pack(pady = 5)

    def cerrarventana():
        root.destroy()
        
    b1 = Button(miframe, text = "Finalizar prueba", 
        command = lambda:[cerrarventana(), mensaje_final(),], 
        anchor = "n", font=("Tahoma", 12))
    b1.pack(pady = 20)

    root.mainloop()


def resultados():

    global item_critico

    root = Tk()

    root.geometry("620x520")
    root.resizable(False, True)
    root.config(bg = "lightblue")

    miframe = Frame(root, width="550", height="500")
    miframe.pack()

    root.title("Inventario de Depresión de Beck")

    T = Label(miframe, text="Esta es la lista de ítems críticos, es decir aquellos ítems calificados con 3",
              anchor = "n", justify = "left", font=("Tahoma", 13), bg = "lightblue", padx = 15, pady = 15).pack()
    


    lista_itemcritico = " "

    for x in item_critico:
        lista_itemcritico += f'{x}\n'

   
    T = Label(miframe, 
        text= lista_itemcritico, 
        anchor = "n", 
        justify = "left", 
        font=("Tahoma", 12), bg="white")
    T.pack(padx = 10, pady = 10)

    
    def cerrarventana():
        root.destroy()

    b1 = Button(root, text = "Cerrar", 
        command = lambda:cerrarventana(), font=("Tahoma", 12), bg = "white" )
    b1.pack(pady = 7)

    root.mainloop()


def mensaje_final():

    global nivel


    root = Tk()
    root.geometry("800x300")
    root.resizable(False, False)
    root.config(bg = "lightblue")

    miframe = Frame(root, width="780", height="250")
    miframe.pack(padx = 20, pady = 20)

    root.title("Inventario de Depresión de Beck")


    T = Label(miframe, text= f'El puntaje obtenido en la prueba es: {SUMA} \n\n{nivel}', 
        anchor = "n", justify = "left", 
        font=("Tahoma", 14), bg="lightblue", padx = 20, pady = 20)
    T.pack()

    def cerrarventana():
        root.destroy()


    b1 = Button(root, text = 'Ver ítems críticos', 
        command = lambda:[cerrarventana(),resultados()], font=("Tahoma", 12)).pack()

    root.mainloop() 

xfile = openpyxl.load_workbook(nombreArchivo)
df = pd.DataFrame(RESPUESTAS)
writer = pd.ExcelWriter(nombreArchivo, engine='xlsxwriter')
df.to_excel(writer, sheet_name= "Resultados", index=False)
writer.save()


finalizar()


# In[ ]:





# In[ ]:




